## ocaml-dune 1.6.2

=== debian/changelog ===
ocaml-dune (1.6.2-4) unstable; urgency=high

  * Upload to unstable
  * Update Vcs-*

 -- Stéphane Glondu <glondu@debian.org>  Sun, 04 Aug 2019 15:28:16 +0200

ocaml-dune (1.6.2-3) experimental; urgency=medium

  * Rename source and main binary package to "ocaml-dune" (Closes: #919953)
  * Bump debhelper compat level to 12
  * Bump Standards-Version to 4.4.0
  * Update Homepage

 -- Stéphane Glondu <glondu@debian.org>  Mon, 29 Jul 2019 14:35:34 +0200

dune (1.6.2-2) unstable; urgency=medium

  * Add Breaks+Replaces: whitedune (<< 0.30.10-2.2) (Closes: #919622)

 -- Stéphane Glondu <glondu@debian.org>  Fri, 18 Jan 2019 17:50:45 +0100

dune (1.6.2-1) unstable; urgency=medium

  * New upstream release
    - add new binary package libdune-ocaml-dev
  * Update debian/watch
  * Update Vcs-*
  * Bump Standards-Version to 4.2.1 (no changes)

 -- Stéphane Glondu <glondu@debian.org>  Sat, 08 Dec 2018 15:27:49 +0100

dune (1.0~beta20-1) unstable; urgency=medium

  * Team upload
  * New upstream version (2018-04-10)
    + Fix FTBFS on bytecode-only archs (Closes: #894088)
  * debian/rules: Keep libdir to /usr/lib/ocaml (Closes: #894545)
  * Bump Standards-Version to 4.1.4.
    No change required.
  * Switch to debhelper 11
  * Package transition to “Dune” (Closes: #896466)
    Upstream renamed the project

 -- Nicolas Braud-Santoni <nicolas@braud-santoni.eu>  Sat, 21 Apr 2018 12:59:57 +0200

jbuilder (1.0~beta19-1) unstable; urgency=medium

  * Team upload
  * New upstream release
    + Updated d/rules to call ./configure manually because it errors
      on extra arguments

 -- Andy Li <andy@onthewings.net>  Mon, 19 Mar 2018 15:21:27 +0800

jbuilder (1.0~beta18-1) unstable; urgency=medium

  * Team upload
  * New upstream release
    * Fix library builds on OCaml bytecode-only architectures
      (Closes: #881770)
  * Update d/jbuilder.opam-install and d/jbuilder.manpages
  * Bump Standards-Version to 4.1.3 (no changes)

 -- Andy Li <andy@onthewings.net>  Wed, 28 Feb 2018 16:36:09 +0800

jbuilder (1.0~beta14-1) unstable; urgency=medium

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Thu, 12 Oct 2017 10:18:46 +0200

jbuilder (1.0~beta11-1) unstable; urgency=medium

  * Initial release (Closes: #870130)

 -- Stéphane Glondu <glondu@debian.org>  Sun, 30 Jul 2017 10:53:53 +0200

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
#export DH_OPTIONS=-v

%:
	dh $@ --with ocaml

.PHONY: override_dh_auto_configure
override_dh_auto_configure:
	./configure --libdir /usr/lib/ocaml

.PHONY: override_dh_auto_build
override_dh_auto_build:
	ocaml bootstrap.ml
	./boot.exe

.PHONY: override_dh_auto_clean
override_dh_auto_clean:
	rm -rf _build boot.exe src/setup.ml dune.install
	find -name .merlin -delete

.PHONY: override_dh_auto_test
override_dh_auto_test:
# Upstream tests assume opam is installed; skip them

.PHONY: override_dh_missing
override_dh_missing:
	dh_missing --fail-missing

override_dh_dwz:

## ocaml-dune 1.11.0

=== Makefile ===
PREFIX_ARG := $(if $(PREFIX),--prefix $(PREFIX),)
LIBDIR_ARG := $(if $(LIBDIR),--libdir $(LIBDIR),)
INSTALL_ARGS := $(PREFIX_ARG) $(LIBDIR_ARG)
BIN := ./_boot/default/bin/main/main_dune.exe

-include Makefile.dev

default: boot.exe
	./boot.exe

release: boot.exe
	./boot.exe --release

boot.exe: bootstrap.ml
	ocaml bootstrap.ml

install:
	$(BIN) install $(INSTALL_ARGS) dune --build-dir _boot

uninstall:
	$(BIN) uninstall $(INSTALL_ARGS) dune --build-dir _boot

reinstall: uninstall reinstall

test:
	$(BIN) runtest

test-js:
	$(BIN) build @runtest-js

test-coq:
	$(BIN) build @runtest-coq

test-all:
	$(BIN) build @runtest @runtest-js @runtest-coq

check:
	$(BIN) build @check

promote:
	$(BIN) promote

accept-corrections: promote

all-supported-ocaml-versions:
	$(BIN) build @install @runtest --workspace dune-workspace.dev --root .

clean:
	rm -f ./boot.exe $(wildcard ./bootstrap.cmi ./bootstrap.cmo ./bootstrap.exe)
	$(BIN) clean || true
	rm -rf _boot

distclean: clean
	rm -f src/setup.ml

doc:
	cd doc && sphinx-build . _build

livedoc:
	cd doc && sphinx-autobuild . _build \
	  -p 8888 -q  --host $(shell hostname) -r '\.#.*'

update-jbuilds: $(BIN)
	$(BIN) build @doc/runtest --auto-promote

# If the first argument is "run"...
ifeq (dune,$(firstword $(MAKECMDGOALS)))
  # use the rest as arguments for "run"
  RUN_ARGS := $(wordlist 2,$(words $(MAKECMDGOALS)),$(MAKECMDGOALS))
  # ...and turn them into do-nothing targets
  $(eval $(RUN_ARGS):;@:)
endif

dune: $(BIN)
	$(BIN) $(RUN_ARGS)

.PHONY: default install uninstall reinstall clean test doc
.PHONY: promote accept-corrections opam-release dune check

opam-release:
	dune-release distrib --skip-build --skip-lint --skip-tests
	dune-release publish distrib --verbose
	dune-release opam pkg
	dune-release opam submit

=== debian/changelog ===
ocaml-dune (1.11.0-2) unstable; urgency=medium

  * Apply patch supplied by upstream to fix FTBFS on armhf

 -- Stéphane Glondu <glondu@debian.org>  Fri, 09 Aug 2019 11:32:47 +0200

ocaml-dune (1.11.0-1) unstable; urgency=medium

  * New upstream release
  * Update debian/watch

 -- Stéphane Glondu <glondu@debian.org>  Fri, 09 Aug 2019 07:36:02 +0200

=== debian/control ===
Source: ocaml-dune
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Stéphane Glondu <glondu@debian.org>
Build-Depends:
 ocaml-nox,
 ocaml-findlib,
 dh-ocaml,
 debhelper (>= 12)
Standards-Version: 4.4.0
Homepage: https://github.com/ocaml/dune
Vcs-Git: https://salsa.debian.org/ocaml-team/ocaml-dune.git
Vcs-Browser: https://salsa.debian.org/ocaml-team/ocaml-dune

Package: ocaml-dune
Architecture: any
Breaks: jbuilder (<< 1.0~beta20-1), whitedune (<< 0.30.10-2.2), dune (<< 1.6.2-3)
Replaces: jbuilder (<< 1.0~beta20-1), whitedune (<< 0.30.10-2.2), dune (<< 1.6.2-3)
Provides: jbuilder
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Description: composable build system for OCaml projects
 Dune is a build system designed for OCaml/Reason projects
 only. It focuses on providing the user with a consistent experience
 and takes care of most of the low-level details of OCaml
 compilation. All you have to do is provide a description of your
 project and Dune will do the rest.

Package: libdune-ocaml-dev
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Suggests:
 ocaml-findlib
Description: composable build system for OCaml projects (library)
 Dune is a build system designed for OCaml/Reason projects
 only. It focuses on providing the user with a consistent experience
 and takes care of most of the low-level details of OCaml
 compilation. All you have to do is provide a description of your
 project and Dune will do the rest.
 .
 This package contains the library.

Package: jbuilder
Section: oldlibs
Architecture: all
Depends: dune, ${misc:Depends}
Description: composable build system for OCaml projects -- transitional package
 Dune is a build system designed for OCaml/Reason projects
 only. It focuses on providing the user with a consistent experience
 and takes care of most of the low-level details of OCaml
 compilation. All you have to do is provide a description of your
 project and Dune will do the rest.
 .
 Dune was previously called jbuilder; this is a transitional package,
 which can be safely removed.

Package: dune
Section: oldlibs
Architecture: all
Depends: ocaml-dune, ${misc:Depends}
Description: composable build system for OCaml projects -- transitional package
 Dune is a build system designed for OCaml/Reason projects
 only. It focuses on providing the user with a consistent experience
 and takes care of most of the low-level details of OCaml
 compilation. All you have to do is provide a description of your
 project and Dune will do the rest.
 .
 ocaml-dune was previously called dune; this is a transitional package,
 which can be safely removed.

=== debian/rules ===
--- 
+++ 
@@ -4,6 +4,12 @@
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
 #export DH_OPTIONS=-v
+
+include /usr/share/ocaml/ocamlvars.mk
+
+export DESTDIR=$(CURDIR)/debian/tmp
+export PREFIX=/usr
+export LIBDIR=..$(OCAML_STDLIB_DIR)
 
 %:
 	dh $@ --with ocaml
@@ -19,7 +25,7 @@
 
 .PHONY: override_dh_auto_clean
 override_dh_auto_clean:
-	rm -rf _build boot.exe src/setup.ml dune.install
+	rm -rf _build _boot boot.exe src/setup.ml dune.install
 	find -name .merlin -delete
 
 .PHONY: override_dh_auto_test

## ocaml-dune 2.1.3

=== Makefile ===
PREFIX_ARG := $(if $(PREFIX),--prefix $(PREFIX),)
LIBDIR_ARG := $(if $(LIBDIR),--libdir $(LIBDIR),)
DESTDIR_ARG := $(if $(DESTDIR),--destdir $(DESTDIR),)
INSTALL_ARGS := $(PREFIX_ARG) $(LIBDIR_ARG) $(DESTDIR_ARG)
BIN := ./dune.exe

-include Makefile.dev

release: $(BIN)
	$(BIN) build -p dune --profile dune-bootstrap

dune.exe: bootstrap.ml boot/libs.ml boot/duneboot.ml
	ocaml bootstrap.ml

all: $(BIN)
	$(BIN) build

install:
	$(BIN) install $(INSTALL_ARGS) dune

uninstall:
	$(BIN) uninstall $(INSTALL_ARGS) dune

reinstall: uninstall install

test: $(BIN)
	$(BIN) runtest

test-js: $(BIN)
	$(BIN) build @runtest-js

test-coq: $(BIN)
	$(BIN) build @runtest-coq

test-all: $(BIN)
	$(BIN) build @runtest @runtest-js @runtest-coq

check: $(BIN)
	$(BIN) build @check

fmt: $(BIN)
	$(BIN) build @fmt --auto-promote

promote: $(BIN)
	$(BIN) promote

accept-corrections: promote

all-supported-ocaml-versions: $(BIN)
	$(BIN) build @install @runtest --workspace dune-workspace.dev --root .

clean: $(BIN)
	$(BIN) clean || true
	rm -rf _boot dune.exe

distclean: clean
	rm -f src/dune/setup.ml

doc:
	cd doc && sphinx-build . _build

livedoc:
	cd doc && sphinx-autobuild . _build \
	  -p 8888 -q  --host $(shell hostname) -r '\.#.*'

update-jbuilds: $(BIN)
	$(BIN) build @doc/runtest --auto-promote

# If the first argument is "run"...
ifeq (dune,$(firstword $(MAKECMDGOALS)))
  # use the rest as arguments for "run"
  RUN_ARGS := $(wordlist 2,$(words $(MAKECMDGOALS)),$(MAKECMDGOALS))
  # ...and turn them into do-nothing targets
  $(eval $(RUN_ARGS):;@:)
endif

dune: $(BIN)
	$(BIN) $(RUN_ARGS)

.PHONY: default install uninstall reinstall clean test doc
.PHONY: promote accept-corrections opam-release dune check fmt

opam-release:
	dune-release distrib --skip-build --skip-lint --skip-tests -n dune
	dune-release publish distrib --verbose -n dune
	dune-release opam pkg -n dune
	dune-release opam submit -n dune

=== debian/changelog ===
ocaml-dune (2.1.3-2) unstable; urgency=high

  * ocaml-dune breaks libsedlex-ocaml-dev (<< 2.1-4)

 -- Stéphane Glondu <glondu@debian.org>  Tue, 04 Feb 2020 13:48:19 +0100

ocaml-dune (2.1.3-1) unstable; urgency=medium

  * New upstream release (Closes: #949810)
    - drop jbuilder binary package
  * Build-depend on debhelper-compat
  * Bump Standards-Version to 4.5.0
  * Add Rules-Requires-Root: no

 -- Stéphane Glondu <glondu@debian.org>  Mon, 27 Jan 2020 09:15:36 +0100

=== debian/control ===
--- 
+++ 
@@ -4,18 +4,22 @@
 Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders: Stéphane Glondu <glondu@debian.org>
 Build-Depends:
+ debhelper-compat (= 12),
  ocaml-nox,
- ocaml-findlib,
- dh-ocaml,
- debhelper (>= 12)
-Standards-Version: 4.4.0
+ dh-ocaml
+Standards-Version: 4.5.0
+Rules-Requires-Root: no
 Homepage: https://github.com/ocaml/dune
 Vcs-Git: https://salsa.debian.org/ocaml-team/ocaml-dune.git
 Vcs-Browser: https://salsa.debian.org/ocaml-team/ocaml-dune
 
 Package: ocaml-dune
 Architecture: any
-Breaks: jbuilder (<< 1.0~beta20-1), whitedune (<< 0.30.10-2.2), dune (<< 1.6.2-3)
+Breaks:
+ libsedlex-ocaml-dev (<< 2.1-4),
+ jbuilder (<< 1.0~beta20-1),
+ whitedune (<< 0.30.10-2.2),
+ dune (<< 1.6.2-3)
 Replaces: jbuilder (<< 1.0~beta20-1), whitedune (<< 0.30.10-2.2), dune (<< 1.6.2-3)
 Provides: jbuilder
 Depends:
@@ -37,28 +41,15 @@
  ${misc:Depends}
 Suggests:
  ocaml-findlib
-Description: composable build system for OCaml projects (library)
+Description: composable build system for OCaml projects (libraries)
  Dune is a build system designed for OCaml/Reason projects
  only. It focuses on providing the user with a consistent experience
  and takes care of most of the low-level details of OCaml
  compilation. All you have to do is provide a description of your
  project and Dune will do the rest.
  .
- This package contains the library.
-
-Package: jbuilder
-Section: oldlibs
-Architecture: all
-Depends: dune, ${misc:Depends}
-Description: composable build system for OCaml projects -- transitional package
- Dune is a build system designed for OCaml/Reason projects
- only. It focuses on providing the user with a consistent experience
- and takes care of most of the low-level details of OCaml
- compilation. All you have to do is provide a description of your
- project and Dune will do the rest.
- .
- Dune was previously called jbuilder; this is a transitional package,
- which can be safely removed.
+ This package contains the libraries dune-private-libs and
+ dune-configurator.
 
 Package: dune
 Section: oldlibs

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
#export DH_OPTIONS=-v

include /usr/share/ocaml/ocamlvars.mk

export DESTDIR=$(CURDIR)/debian/tmp
export PREFIX=/usr
export LIBDIR=..$(OCAML_STDLIB_DIR)

%:
	dh $@ --with ocaml

override_dh_auto_clean:
	dh_auto_clean
	rm -rf _tmp

override_dh_auto_configure:
	./configure --libdir /usr/lib/ocaml

override_dh_auto_build:
	ocaml bootstrap.ml
	./dune.exe build -p dune --profile dune-bootstrap
	./dune.exe install --destdir=$(CURDIR)/_tmp --prefix=/usr --libdir=..$(OCAML_STDLIB_DIR) dune
	PATH=$(CURDIR)/_tmp/usr/bin:$(PATH) OCAMLPATH=$(CURDIR)/_tmp$(OCAML_STDLIB_DIR) dune build -p dune-private-libs
	PATH=$(CURDIR)/_tmp/usr/bin:$(PATH) OCAMLPATH=$(CURDIR)/_tmp$(OCAML_STDLIB_DIR) dune install --destdir=$(CURDIR)/_tmp --prefix=/usr --libdir=..$(OCAML_STDLIB_DIR) dune-private-libs
	PATH=$(CURDIR)/_tmp/usr/bin:$(PATH) OCAMLPATH=$(CURDIR)/_tmp$(OCAML_STDLIB_DIR) dune build -p dune-configurator
	PATH=$(CURDIR)/_tmp/usr/bin:$(PATH) OCAMLPATH=$(CURDIR)/_tmp$(OCAML_STDLIB_DIR) dune install --destdir=$(CURDIR)/_tmp --prefix=/usr --libdir=..$(OCAML_STDLIB_DIR) dune-configurator

override_dh_auto_install:
	rm -rf debian/tmp
	cp -a _tmp debian/tmp
	rm -rf debian/tmp/usr/doc/dune-private-libs debian/tmp/usr/doc/dune-configurator debian/tmp/usr/doc/dune/LICENSE.md

override_dh_auto_test:
# Upstream tests assume opam is installed; skip them

override_dh_missing:
	dh_missing --fail-missing

=== debian/watch ===
version=3
opts=uversionmangle=s/\.beta/~beta/ \
https://github.com/ocaml/dune/releases .*/dune-(?:build-info-)?(.*)\.tbz

## ocaml-dune 2.7.0

=== Makefile ===
--- 
+++ 
@@ -1,16 +1,37 @@
+.DEFAULT_GOAL := help
+
 PREFIX_ARG := $(if $(PREFIX),--prefix $(PREFIX),)
 LIBDIR_ARG := $(if $(LIBDIR),--libdir $(LIBDIR),)
 DESTDIR_ARG := $(if $(DESTDIR),--destdir $(DESTDIR),)
 INSTALL_ARGS := $(PREFIX_ARG) $(LIBDIR_ARG) $(DESTDIR_ARG)
 BIN := ./dune.exe
 
+# Dependencies used for developing and testing dune
+DEV_DEPS := \
+core_bench \
+menhir \
+merlin \
+ocamlformat \
+odoc \
+ppx_expect \
+ppx_inline_test \
+ppxlib \
+cinaps \
+utop
+
 -include Makefile.dev
+
+help:
+	@cat doc/make-help.txt
 
 release: $(BIN)
 	$(BIN) build -p dune --profile dune-bootstrap
 
 dune.exe: bootstrap.ml boot/libs.ml boot/duneboot.ml
 	ocaml bootstrap.ml
+
+dev: $(BIN)
+	$(BIN) build @install
 
 all: $(BIN)
 	$(BIN) build
@@ -22,6 +43,10 @@
 	$(BIN) uninstall $(INSTALL_ARGS) dune
 
 reinstall: uninstall install
+
+dev-switch:
+	opam switch create -y . --deps-only --with-test
+	opam install -y $(DEV_DEPS)
 
 test: $(BIN)
 	$(BIN) runtest
@@ -77,11 +102,12 @@
 dune: $(BIN)
 	$(BIN) $(RUN_ARGS)
 
-.PHONY: default install uninstall reinstall clean test doc
+.PHONY: default install uninstall reinstall clean test doc dev-switch
 .PHONY: promote accept-corrections opam-release dune check fmt
 
 opam-release:
 	dune-release distrib --skip-build --skip-lint --skip-tests -n dune
-	dune-release publish distrib --verbose -n dune
+	# See https://github.com/ocamllabs/dune-release/issues/206
+	DUNE_RELEASE_DELEGATE=github-dune-release-delegate dune-release publish distrib --verbose -n dune
 	dune-release opam pkg -n dune
 	dune-release opam submit -n dune

=== debian/changelog ===
ocaml-dune (2.7.0-1) unstable; urgency=medium

  * New upstream release
  * Bump debhelper compat level to 13

 -- Stéphane Glondu <glondu@debian.org>  Sat, 22 Aug 2020 11:07:12 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders: Stéphane Glondu <glondu@debian.org>
 Build-Depends:
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
  ocaml-nox,
  dh-ocaml
 Standards-Version: 4.5.0

## ocaml-dune 2.7.1

=== Makefile ===
--- 
+++ 
@@ -6,18 +6,33 @@
 INSTALL_ARGS := $(PREFIX_ARG) $(LIBDIR_ARG) $(DESTDIR_ARG)
 BIN := ./dune.exe
 
-# Dependencies used for developing and testing dune
-DEV_DEPS := \
+# Dependencies used for testing dune, when developed locally and
+# when tested in CI
+TEST_DEPS := \
+bisect_ppx \
+cinaps \
+coq \
 core_bench \
+"csexp>=1.3.0" \
+js_of_ocaml-ppx \
+js_of_ocaml-compiler \
+"mdx=1.6.0" \
 menhir \
 merlin \
-ocamlformat \
-odoc \
-ppx_expect \
+ocaml-migrate-parsetree \
+ocamlfind \
+ocamlformat.0.14.3 \
+"odoc>=1.5.0" \
+"ppx_expect>=v0.14" \
 ppx_inline_test \
-ppxlib \
-cinaps \
-utop
+"ppxlib.0.13.0" \
+result \
+"utop>=2.6.0"
+
+# Dependencies recommended for developing dune locally,
+# but not wanted in CI
+DEV_DEPS := \
+patdiff
 
 -include Makefile.dev
 
@@ -44,12 +59,21 @@
 
 reinstall: uninstall install
 
+dev-deps:
+	opam install -y $(TEST_DEPS)
+
 dev-switch:
-	opam switch create -y . --deps-only --with-test
-	opam install -y $(DEV_DEPS)
+	opam update
+	# Ensuring that either a dev switch already exists or a new one is created
+	[[ $(shell opam switch show) == $(shell pwd) ]] || \
+		opam switch create -y . --deps-only --with-test
+	opam install -y $(TEST_DEPS) $(DEV_DEPS)
 
 test: $(BIN)
 	$(BIN) runtest
+
+test-windows: $(BIN)
+	$(BIN) build @runtest-windows
 
 test-js: $(BIN)
 	$(BIN) build @runtest-js

=== debian/changelog ===
ocaml-dune (2.7.1-2) unstable; urgency=medium

  * Cherry-pick upstream configure fix (Closes: #975894)

 -- Stéphane Glondu <glondu@debian.org>  Sat, 28 Nov 2020 11:08:20 +0100

ocaml-dune (2.7.1-1) unstable; urgency=medium

  [ Stéphane Glondu ]
  * New upstream release

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

 -- Stéphane Glondu <glondu@debian.org>  Tue, 24 Nov 2020 09:28:02 +0100

=== debian/rules ===
--- 
+++ 
@@ -37,6 +37,3 @@
 
 override_dh_auto_test:
 # Upstream tests assume opam is installed; skip them
-
-override_dh_missing:
-	dh_missing --fail-missing

## ocaml-dune 2.9.1

=== debian/changelog ===
ocaml-dune (2.9.1-1build1) jammy; urgency=medium

  * No-change rebuild for ocaml abi changes.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 24 Jan 2022 17:19:45 +0100

ocaml-dune (2.9.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 2.9.1
  * Drop upstreamed patches

 -- Kyle Robbertze <paddatrapper@debian.org>  Tue, 30 Nov 2021 16:14:22 +0200

=== debian/control ===
--- 
+++ 
@@ -6,6 +6,7 @@
 Build-Depends:
  debhelper-compat (= 13),
  ocaml-nox,
+ libcsexp-ocaml-dev,
  dh-ocaml
 Standards-Version: 4.5.0
 Rules-Requires-Root: no

## ocaml-dune 2.9.3

=== Makefile ===
--- 
+++ 
@@ -11,21 +11,20 @@
 TEST_DEPS := \
 bisect_ppx \
 cinaps \
-coq \
+coq-native \
+"coq>=8.12.1" \
 core_bench \
 "csexp>=1.3.0" \
-js_of_ocaml-ppx \
+js_of_ocaml \
 js_of_ocaml-compiler \
-"mdx=1.6.0" \
+mdx \
 menhir \
-merlin \
-ocaml-migrate-parsetree \
 ocamlfind \
-ocamlformat.0.14.3 \
+ocamlformat.0.17.0 \
 "odoc>=1.5.0" \
 "ppx_expect>=v0.14" \
 ppx_inline_test \
-"ppxlib.0.13.0" \
+ppxlib \
 result \
 "utop>=2.6.0"
 
@@ -64,9 +63,9 @@
 
 dev-switch:
 	opam update
-	# Ensuring that either a dev switch already exists or a new one is created
+# Ensuring that either a dev switch already exists or a new one is created
 	[[ $(shell opam switch show) == $(shell pwd) ]] || \
-		opam switch create -y . --deps-only --with-test
+		opam switch create -y . 4.10.0 --deps-only --with-test
 	opam install -y $(TEST_DEPS) $(DEV_DEPS)
 
 test: $(BIN)
@@ -103,7 +102,7 @@
 	rm -rf _boot dune.exe
 
 distclean: clean
-	rm -f src/dune/setup.ml
+	rm -f src/dune_rules/setup.ml
 
 doc:
 	cd doc && sphinx-build . _build
@@ -127,11 +126,17 @@
 	$(BIN) $(RUN_ARGS)
 
 .PHONY: default install uninstall reinstall clean test doc dev-switch
-.PHONY: promote accept-corrections opam-release dune check fmt
+.PHONY: promote accept-corrections release opam-release dune check fmt
 
-opam-release:
+# Use this target to make sure that we always run the in source dune when making
+# the release
+opam-release: dev
+	$(BIN) exec -- $(MAKE) dune-release
+
+dune-release:
+	dune-release tag
 	dune-release distrib --skip-build --skip-lint --skip-tests -n dune
-	# See https://github.com/ocamllabs/dune-release/issues/206
+# See https://github.com/ocamllabs/dune-release/issues/206
 	DUNE_RELEASE_DELEGATE=github-dune-release-delegate dune-release publish distrib --verbose -n dune
 	dune-release opam pkg -n dune
 	dune-release opam submit -n dune

=== debian/changelog ===
ocaml-dune (2.9.3-1) unstable; urgency=medium

  * New upstream release
  * Add pkg.ocaml-dune.nocsexp build profile, to cut build-dependency
    loop if needed

 -- Stéphane Glondu <glondu@debian.org>  Wed, 01 Feb 2023 08:50:59 +0100

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 Build-Depends:
  debhelper-compat (= 13),
  ocaml-nox,
- libcsexp-ocaml-dev,
+ libcsexp-ocaml-dev <!pkg.ocaml-dune.nocsexp>,
  dh-ocaml
 Standards-Version: 4.5.0
 Rules-Requires-Root: no
@@ -36,6 +36,7 @@
 
 Package: libdune-ocaml-dev
 Architecture: any
+Build-Profiles: <!pkg.ocaml-dune.nocsexp>
 Depends:
  ${ocaml:Depends},
  ${shlibs:Depends},

=== debian/rules ===
--- 
+++ 
@@ -25,10 +25,12 @@
 	ocaml bootstrap.ml
 	./dune.exe build -p dune --profile dune-bootstrap
 	./dune.exe install --destdir=$(CURDIR)/_tmp --prefix=/usr --libdir=..$(OCAML_STDLIB_DIR) dune
+ifneq (,$(filter libdune-ocaml-dev,$(shell dh_listpackages)))
 	PATH=$(CURDIR)/_tmp/usr/bin:$(PATH) OCAMLPATH=$(CURDIR)/_tmp$(OCAML_STDLIB_DIR) dune build -p dune-private-libs
 	PATH=$(CURDIR)/_tmp/usr/bin:$(PATH) OCAMLPATH=$(CURDIR)/_tmp$(OCAML_STDLIB_DIR) dune install --destdir=$(CURDIR)/_tmp --prefix=/usr --libdir=..$(OCAML_STDLIB_DIR) dune-private-libs
 	PATH=$(CURDIR)/_tmp/usr/bin:$(PATH) OCAMLPATH=$(CURDIR)/_tmp$(OCAML_STDLIB_DIR) dune build -p dune-configurator
 	PATH=$(CURDIR)/_tmp/usr/bin:$(PATH) OCAMLPATH=$(CURDIR)/_tmp$(OCAML_STDLIB_DIR) dune install --destdir=$(CURDIR)/_tmp --prefix=/usr --libdir=..$(OCAML_STDLIB_DIR) dune-configurator
+endif
 
 override_dh_auto_install:
 	rm -rf debian/tmp

## ocaml-dune 3.10.0

=== Makefile ===
.DEFAULT_GOAL := help

PREFIX_ARG := $(if $(PREFIX),--prefix $(PREFIX),)
LIBDIR_ARG := $(if $(LIBDIR),--libdir $(LIBDIR),)
DESTDIR_ARG := $(if $(DESTDIR),--destdir $(DESTDIR),)
INSTALL_ARGS := $(PREFIX_ARG) $(LIBDIR_ARG) $(DESTDIR_ARG)
BIN := ./_boot/dune.exe

# Dependencies used for testing dune, when developed locally and
# when tested in CI
TEST_DEPS := \
lwt \
cinaps \
core_bench \
"csexp>=1.3.0" \
js_of_ocaml \
js_of_ocaml-compiler \
"mdx>=2.3.0" \
menhir \
ocamlfind \
ocamlformat.$$(awk -F = '$$1 == "version" {print $$2}' .ocamlformat) \
"odoc>=2.0.1" \
"ppx_expect.v0.15.0" \
ppx_inline_test \
ppxlib \
ctypes \
"utop>=2.6.0" \
"melange>=1.0.0" \
"rescript-syntax"
# Dependencies recommended for developing dune locally,
# but not wanted in CI
DEV_DEPS := \
"dkml-workflows>=1.2.0" \
patdiff

TEST_OCAMLVERSION := 4.14.1

-include Makefile.dev

.PHONY: help
help:
	@cat doc/make-help.txt

.PHONY: bootstrap
bootstrap:
	$(MAKE) -B $(BIN)

.PHONY: release
release: $(BIN)
	@$(BIN) build @install -p dune --profile dune-bootstrap

$(BIN):
	@ocaml boot/bootstrap.ml

dev: $(BIN)
	$(BIN) build @install

all: $(BIN)
	$(BIN) build

.PHONY: install
install:
	$(BIN) install $(INSTALL_ARGS) dune

.PHONY: uninstall
uninstall:
	$(BIN) uninstall $(INSTALL_ARGS) dune

.PHONY: reinstall
reinstall: uninstall install

install-ocamlformat:
	opam install -y ocamlformat.$$(awk -F = '$$1 == "version" {print $$2}' .ocamlformat)

dev-depext:
	opam depext -y $(TEST_DEPS)

.PHONY: dev-deps
dev-deps:
	opam install -y $(TEST_DEPS)

.PHONY: coverage-deps
coverage-deps:
	opam install -y bisect_ppx

.PHONY: dev-switch
dev-switch:
	opam update
# Ensuring that either a dev switch already exists or a new one is created
	test "$(shell opam switch show)" = "$(shell pwd)" || \
		opam switch create -y . $(TEST_OCAMLVERSION) --deps-only --with-test
	opam install -y --update-invariant ocaml.$(TEST_OCAMLVERSION) $(TEST_DEPS) $(DEV_DEPS)

.PHONY: test
test: $(BIN)
	$(BIN) runtest

test-windows: $(BIN)
	$(BIN) build @runtest-windows

test-js: $(BIN)
	$(BIN) build @runtest-js

test-coq: $(BIN)
	DUNE_COQ_TEST=enable $(BIN) build @runtest-coq

test-melange: $(BIN)
	$(BIN) build @runtest-melange

test-all: $(BIN)
	$(BIN) build @runtest @runtest-js @runtest-coq @runtest-melange

test-coverage: $(BIN)
	- $(BIN) build --instrument-with bisect_ppx --force @runtest
	bisect-ppx-report send-to Coveralls

.PHONY: check
check: $(BIN)
	@$(BIN) build @check

.PHONY: fmt
fmt: $(BIN)
	@$(BIN) fmt

.PHONY: promote
promote: $(BIN)
	@$(BIN) promote

.PHONY: accept-corrections
accept-corrections: promote

all-supported-ocaml-versions: $(BIN)
	$(BIN) build @install @runtest --workspace dune-workspace.dev --root .

.PHONY: clean
clean:
	rm -rf _boot _build

distclean: clean
	rm -f src/dune_rules/setup.ml

.PHONY: doc
doc:
	sphinx-build -W doc doc/_build

# livedoc-deps: you may need to [pip3 install sphinx-autobuild] and [pip3 install -r doc/requirements.txt]
livedoc:
	cd doc && sphinx-autobuild . _build --port 8888 -q --re-ignore '\.#.*'

update-jbuilds: $(BIN)
	$(BIN) build @doc/runtest --auto-promote

# you will need to use a dev-switch or do opam install dkml-workflows.
# we run --auto-promote twice since first may fail (ex. missing files with Unable to resolve symlink)
update-dkml: $(BIN)
	opam exec -- generate-setup-dkml-scaffold
	$(BIN) build @gen-dkml --auto-promote || $(BIN) build @gen-dkml --auto-promote
	rm -rf ci/setup-dkml/gh-darwin ci/setup-dkml/gh-linux ci/setup-dkml/gl
	rm -rf ci/setup-dkml/pc/setup-dkml-darwin_*.sh ci/setup-dkml/pc/setup-dkml-linux_*.sh
	$(BIN) build @ci/fmt --auto-promote || $(BIN) build @ci/fmt --auto-promote

# assumes MSYS2 or Cygwin, and Visual Studio. Do not use 'with-dkml make ...'
desktop-ci-windows_x86:
	if command -v pwsh; then \
	  pwsh ./ci/setup-dkml/pc/setup-dkml-windows_x86.ps1; \
	else \
	  powershell ./ci/setup-dkml/pc/setup-dkml-windows_x86.ps1; \
	fi
	/usr/bin/env PATH=/usr/bin \
	  dkml_host_abi=windows_x86 abi_pattern=win32-windows_x86_64; \
	  opam_root=.ci/o exe_ext=.exe \
	  /bin/sh ci/build-test.sh

# assumes MSYS2 or Cygwin, and Visual Studio. Do not use 'with-dkml make ...'
desktop-ci-windows_x86_64:
	if command -v pwsh; then \
	  pwsh ./ci/setup-dkml/pc/setup-dkml-windows_x86_64.ps1; \
	else \
	  powershell ./ci/setup-dkml/pc/setup-dkml-windows_x86_64.ps1; \
	fi
	/usr/bin/env PATH=/usr/bin \
	  dkml_host_abi=windows_x86 abi_pattern=win32-windows_x86_64 \
	  opam_root=.ci/o exe_ext=.exe \
	  /bin/sh ci/build-test.sh

# If the first argument is "run"...
ifeq (dune,$(firstword $(MAKECMDGOALS)))
  # use the rest as arguments for "run"
  RUN_ARGS := $(wordlist 2,$(words $(MAKECMDGOALS)),$(MAKECMDGOALS))
  # ...and turn them into do-nothing targets
  $(eval $(RUN_ARGS):;@:)
endif

.PHONY: bench
bench: $(BIN)
	@$(BIN) exec -- ./bench/bench.exe $(BIN)

.PHONY: dune
dune: $(BIN)
	$(BIN) $(RUN_ARGS)

# Use this target to make sure that we always run the in source dune when making
# the release
.PHONY: opam-release
opam-release: dev
	$(BIN) exec -- $(MAKE) dune-release

dune-release:
	dune-release tag
	dune-release distrib --skip-build --skip-lint --skip-tests
# See https://github.com/ocamllabs/dune-release/issues/206
	DUNE_RELEASE_DELEGATE=github-dune-release-delegate dune-release publish distrib --verbose
	dune-release opam pkg
	dune-release opam submit

.PHONY: docker-build-image
docker-build-image:
	docker build -f docker/dev.Dockerfile -t dune .

.PHONY: docker-compose
docker-compose:
	docker compose -f docker/dev.yml run dune bash

=== bench/monorepo/Makefile ===
# Intended to be used from inside docker containers built from bench.Dockerfile
RUNNER = /home/user/monorepo-benchmark/dune-monorepo-benchmark-runner/_build/default/src/main.exe
DUNE_EXE_PATH = /home/user/dune/_build/default/bin/main.exe
BUILD_TARGET = ./monorepo_bench.exe
MONOREPO_PATH = /home/user/monorepo-benchmark/benchmark
USER_GROUP = user:users

# This benchmark is intended to run on current-bench where the duniverse
# directory is expected to exist at this path. See the readme for info on
# running this benchmark locally.
DUNIVERSE_MOUNT_POINT = /home/opam/bench-dir/current-bench-data/duniverse

# Copy the duniverse directory as root in case the regular user doesn't have
# permission to read from the mount point.
duniverse:
	sudo cp -a $(DUNIVERSE_MOUNT_POINT) .
	sudo chown -hR $(USER_GROUP) duniverse

# Run the dune benchmark runner. To reduce noise, short benchmarks are run 5
# times each, and the max and min results of each benchmark are discarded. The
# remaining 3 results are presented to current-bench. Short benchmarks are all
# benchmarks except for the initial build from scratch.
bench: duniverse
	$(RUNNER) \
		--dune-exe-path=$(DUNE_EXE_PATH) \
		--build-target=$(BUILD_TARGET) \
		--monorepo-path=$(MONOREPO_PATH) \
		--print-dune-output \
		--num-short-job-repeats=5 \
		--remove-outliers=1

clean:
	dune clean

.PHONY: bench clean

=== debian/changelog ===
ocaml-dune (3.10.0-1) unstable; urgency=medium

  * New upstream release
  * Simplify debian/rules
  * Update debian/watch

 -- Stéphane Glondu <glondu@debian.org>  Sat, 26 Aug 2023 07:28:27 +0200

ocaml-dune (3.9.1-1) unstable; urgency=medium

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Sun, 16 Jul 2023 11:41:12 +0200

ocaml-dune (3.9.0-3) unstable; urgency=medium

  [ Pino Toscano ]
  * Deal with PIPE_BUF not present (as in GNU/Hurd), applying a patch
    proposed for the OCaml 'spawn' library; patch
    vendor-spawn-pipe_buf.diff.

  [ Dan Bungert ]
  * Add dh_ocaml compatible substitution variables per OCaml packaging
    policy (Closes: #1040874)

 -- Stéphane Glondu <glondu@debian.org>  Thu, 13 Jul 2023 08:14:09 +0200

ocaml-dune (3.9.0-2) unstable; urgency=medium

  * Team upload.
  * Ship xdg (used by utop 2.13.x).

 -- Julien Puydt <jpuydt@debian.org>  Wed, 05 Jul 2023 10:40:57 +0200

ocaml-dune (3.9.0-1) unstable; urgency=medium

  * Team upload.
  * Install stdune in the -dev package (Closes: #1040344).
  * New upstream release.

 -- Julien Puydt <jpuydt@debian.org>  Wed, 05 Jul 2023 09:57:47 +0200

ocaml-dune (3.8.2-1) unstable; urgency=medium

  * Team upload.
  * Fix d/watch.
  * Drop transitional dune package (Closes: #1038290).
  * Bump standards-version to 4.6.2.
  * New upstream release.
  * Adapt the building rules to the new upstream.

 -- Julien Puydt <jpuydt@debian.org>  Mon, 03 Jul 2023 18:32:07 +0200

=== debian/control ===
--- 
+++ 
@@ -5,10 +5,10 @@
 Uploaders: Stéphane Glondu <glondu@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
- ocaml-nox,
+ ocaml,
  libcsexp-ocaml-dev <!pkg.ocaml-dune.nocsexp>,
  dh-ocaml
-Standards-Version: 4.5.0
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: https://github.com/ocaml/dune
 Vcs-Git: https://salsa.debian.org/ocaml-team/ocaml-dune.git
@@ -41,6 +41,8 @@
  ${ocaml:Depends},
  ${shlibs:Depends},
  ${misc:Depends}
+Provides:
+ ${ocaml:Provides}
 Suggests:
  ocaml-findlib
 Description: composable build system for OCaml projects (libraries)
@@ -52,17 +54,3 @@
  .
  This package contains the libraries dune-private-libs and
  dune-configurator.
-
-Package: dune
-Section: oldlibs
-Architecture: all
-Depends: ocaml-dune, ${misc:Depends}
-Description: composable build system for OCaml projects -- transitional package
- Dune is a build system designed for OCaml/Reason projects
- only. It focuses on providing the user with a consistent experience
- and takes care of most of the low-level details of OCaml
- compilation. All you have to do is provide a description of your
- project and Dune will do the rest.
- .
- ocaml-dune was previously called dune; this is a transitional package,
- which can be safely removed.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
#export DH_OPTIONS=-v

include /usr/share/ocaml/ocamlvars.mk

DESTDIR=$(CURDIR)/debian/tmp

%:
	dh $@ --with ocaml

override_dh_auto_configure:
	./configure --libdir $(OCAML_STDLIB_DIR)

override_dh_auto_build:
	ocaml boot/bootstrap.ml
	./dune.exe build --profile dune-bootstrap dune.install
	./dune.exe build stdune.install dune-private-libs.install dune-configurator.install xdg.install

override_dh_auto_install:
	./dune.exe install --destdir=$(DESTDIR) --prefix=/usr --libdir=$(OCAML_STDLIB_DIR) dune dune-private-libs dune-configurator stdune xdg
	rm -rf debian/tmp/usr/doc/dune-private-libs debian/tmp/usr/doc/dune-configurator debian/tmp/usr/doc/stdune debian/tmp/usr/doc/xdg debian/tmp/usr/doc/dune/LICENSE.md

override_dh_auto_test:
# Upstream tests assume opam is installed; skip them

## ocaml-dune 3.14.0

=== Makefile ===
--- 
+++ 
@@ -20,13 +20,12 @@
 ocamlfind \
 ocamlformat.$$(awk -F = '$$1 == "version" {print $$2}' .ocamlformat) \
 "odoc>=2.0.1" \
-"ppx_expect.v0.15.0" \
+"ppx_expect>=v0.16.0" \
 ppx_inline_test \
 ppxlib \
 ctypes \
 "utop>=2.6.0" \
-"melange>=1.0.0" \
-"rescript-syntax"
+"melange>=3.0.0"
 # Dependencies recommended for developing dune locally,
 # but not wanted in CI
 DEV_DEPS := \

=== doc/requirements.txt ===
sphinx >= 4.5.0, < 6
sphinx_rtd_theme >= 1.0.0
sphinx-copybutton >= 0.5.0

=== debian/changelog ===
ocaml-dune (3.14.0-1) unstable; urgency=medium

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Wed, 14 Feb 2024 17:05:24 +0100

ocaml-dune (3.11.1-1) unstable; urgency=medium

  * New upstream release
    - fix: --ignore-promoted-rules should work on internal rules
      (Closes: #1050003)

 -- Stéphane Glondu <glondu@debian.org>  Sat, 14 Oct 2023 09:50:48 +0200

ocaml-dune (3.10.0-2) unstable; urgency=medium

  * Build dune-build-info, dune-site, dyn and ordering

 -- Stéphane Glondu <glondu@debian.org>  Fri, 06 Oct 2023 06:40:44 +0200

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,6 @@
 Build-Depends:
  debhelper-compat (= 13),
  ocaml,
- libcsexp-ocaml-dev <!pkg.ocaml-dune.nocsexp>,
  dh-ocaml
 Standards-Version: 4.6.2
 Rules-Requires-Root: no
@@ -33,10 +32,12 @@
  and takes care of most of the low-level details of OCaml
  compilation. All you have to do is provide a description of your
  project and Dune will do the rest.
+ .
+ This package contains the dune executable.
 
 Package: libdune-ocaml-dev
 Architecture: any
-Build-Profiles: <!pkg.ocaml-dune.nocsexp>
+Build-Profiles: <!pkg.ocaml-dune.bootstrap>
 Depends:
  ${ocaml:Depends},
  ${shlibs:Depends},
@@ -52,5 +53,5 @@
  compilation. All you have to do is provide a description of your
  project and Dune will do the rest.
  .
- This package contains the libraries dune-private-libs and
- dune-configurator.
+ This package contains libraries provided by the ocaml-dune source
+ package.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
#export DH_OPTIONS=-v

include /usr/share/ocaml/ocamlvars.mk

DESTDIR=$(CURDIR)/debian/tmp

DEB_DUNE_OTHER_PACKAGES := dune-private-libs dune-configurator dune-build-info dune-site stdune xdg dyn ordering

DEB_DUNE_ALL_PACKAGES := dune
ifeq (,$(filter pkg.ocaml-dune.bootstrap,$(DEB_BUILD_PROFILES)))
DEB_DUNE_ALL_PACKAGES += $(DEB_DUNE_OTHER_PACKAGES)
endif

%:
	dh $@ --with ocaml

override_dh_auto_configure:
	./configure --libdir $(OCAML_STDLIB_DIR)

override_dh_auto_build:
	ocaml boot/bootstrap.ml
	./dune.exe build --profile dune-bootstrap dune.install
ifeq (,$(filter pkg.ocaml-dune.bootstrap,$(DEB_BUILD_PROFILES)))
	./dune.exe build $(addsuffix .install,$(DEB_DUNE_OTHER_PACKAGES))
endif

override_dh_auto_install:
	./dune.exe install --destdir=$(DESTDIR) --prefix=/usr --libdir=$(OCAML_STDLIB_DIR) $(DEB_DUNE_ALL_PACKAGES)
ifeq (,$(filter pkg.ocaml-dune.bootstrap,$(DEB_BUILD_PROFILES)))
	rm -rf $(addprefix debian/tmp/usr/doc/,$(DEB_DUNE_OTHER_PACKAGES))
endif
	rm -f debian/tmp/usr/doc/dune/LICENSE.md

override_dh_auto_test:
# Upstream tests assume opam is installed; skip them

## ocaml-dune 3.15.3

=== Makefile ===
--- 
+++ 
@@ -19,13 +19,13 @@
 menhir \
 ocamlfind \
 ocamlformat.$$(awk -F = '$$1 == "version" {print $$2}' .ocamlformat) \
-"odoc>=2.0.1" \
+"odoc>=2.4.0" \
 "ppx_expect>=v0.16.0" \
 ppx_inline_test \
 ppxlib \
 ctypes \
 "utop>=2.6.0" \
-"melange>=3.0.0"
+"melange"
 # Dependencies recommended for developing dune locally,
 # but not wanted in CI
 DEV_DEPS := \
@@ -74,13 +74,21 @@
 dev-depext:
 	opam depext -y $(TEST_DEPS)
 
+.PHONY: melange
+melange:
+	opam pin add -n melange.dev https://github.com/melange-re/melange.git#v4-414-dev
+
 .PHONY: dev-deps
-dev-deps:
+dev-deps: melange
 	opam install -y $(TEST_DEPS)
 
 .PHONY: coverage-deps
 coverage-deps:
 	opam install -y bisect_ppx
+
+.PHONY: dev-deps-sans-melange
+dev-deps-sans-melange:
+	opam install -y $(TEST_DEPS)
 
 .PHONY: dev-switch
 dev-switch:
@@ -108,6 +116,9 @@
 
 test-all: $(BIN)
 	$(BIN) build @runtest @runtest-js @runtest-coq @runtest-melange
+
+test-all-sans-melange: $(BIN)
+	$(BIN) build @runtest @runtest-js @runtest-coq
 
 test-coverage: $(BIN)
 	- $(BIN) build --instrument-with bisect_ppx --force @runtest

=== debian/changelog ===
ocaml-dune (3.15.3-2) unstable; urgency=medium

  * Build in release mode

 -- Stéphane Glondu <glondu@debian.org>  Sat, 15 Jun 2024 08:04:04 +0200

ocaml-dune (3.15.3-1) unstable; urgency=medium

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Mon, 03 Jun 2024 09:10:27 +0200

## ocaml-dune 3.16.0

=== debian/changelog ===
ocaml-dune (3.16.0-2build1) oracular; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 09 Aug 2024 14:06:50 +0200

ocaml-dune (3.16.0-2) unstable; urgency=medium

  * Add support for a different OCaml stdlib dir

 -- Stéphane Glondu <glondu@debian.org>  Sat, 03 Aug 2024 05:09:05 +0200

ocaml-dune (3.16.0-1) unstable; urgency=medium

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Fri, 12 Jul 2024 13:28:49 +0200

## ocaml-dune 3.17.1

=== debian/changelog ===
ocaml-dune (3.17.1-2) unstable; urgency=medium

  * Add ocplib-simplex-ocaml-dev (<< 0.5.1-3~) to Breaks

 -- Stéphane Glondu <glondu@debian.org>  Thu, 09 Jan 2025 08:05:42 +0100

ocaml-dune (3.17.1-1) unstable; urgency=medium

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Sun, 29 Dec 2024 20:44:57 +0100

## ocaml-dune 3.17.2

=== Makefile ===
.DEFAULT_GOAL := help

PREFIX_ARG := $(if $(PREFIX),--prefix $(PREFIX),)
LIBDIR_ARG := $(if $(LIBDIR),--libdir $(LIBDIR),)
DESTDIR_ARG := $(if $(DESTDIR),--destdir $(DESTDIR),)
INSTALL_ARGS := $(PREFIX_ARG) $(LIBDIR_ARG) $(DESTDIR_ARG)
BIN := ./_boot/dune.exe

# Dependencies recommended for developing dune locally,
# but not wanted in CI
DEV_DEPS := \
core_bench \
patdiff

TEST_OCAMLVERSION := 5.1.1

-include Makefile.dev

.PHONY: help
help:
	@cat doc/make-help.txt

.PHONY: bootstrap
bootstrap:
	$(MAKE) -B $(BIN)

.PHONY: release
release: $(BIN)
	@$(BIN) build @install -p dune --profile dune-bootstrap

$(BIN):
	@ocaml boot/bootstrap.ml

dev: $(BIN)
	$(BIN) build @install

watch: $(BIN)
	$(BIN) build @install --watch

all: $(BIN)
	$(BIN) build

.PHONY: install
install:
	$(BIN) install $(INSTALL_ARGS) dune

.PHONY: uninstall
uninstall:
	$(BIN) uninstall $(INSTALL_ARGS) dune

.PHONY: reinstall
reinstall: uninstall install

.PHONY: install-ocamlformat
install-ocamlformat:
	opam install -y ocamlformat.$$(awk -F = '$$1 == "version" {print $$2}' .ocamlformat)

.PHONY: dev-deps
dev-deps:
	opam install -y . --deps-only --with-dev-setup

.PHONY: coverage-deps
coverage-deps:
	opam install -y bisect_ppx

.PHONY: dev-deps-sans-melange
dev-deps-sans-melange: dev-deps

.PHONY: dev-switch
dev-switch:
	opam update
# Ensuring that either a dev switch already exists or a new one is created
	if test -d _opam ; then \
		opam install -y --update-invariant ocaml.$(TEST_OCAMLVERSION); \
	else \
		opam switch create -y . $(TEST_OCAMLVERSION) --no-install ; \
	fi
	opam install -y . --deps-only --with-test --with-dev-setup
	$(MAKE) install-ocamlformat
	opam install -y $(DEV_DEPS)

.PHONY: test
test: $(BIN)
	$(BIN) runtest

test-windows: $(BIN)
	$(BIN) build @runtest-windows

test-js: $(BIN)
	$(BIN) build @runtest-js

test-wasm: $(BIN)
	DUNE_WASM_TEST=enable $(BIN) build @runtest-wasm

test-coq: $(BIN)
	DUNE_COQ_TEST=enable $(BIN) build @runtest-coq

test-melange: $(BIN)
	$(BIN) build @runtest-melange

test-all: $(BIN)
	$(BIN) build @runtest @runtest-js @runtest-coq @runtest-melange

test-all-sans-melange: $(BIN)
	$(BIN) build @runtest @runtest-js @runtest-coq

test-coverage: $(BIN)
	- $(BIN) build --instrument-with bisect_ppx --force @runtest
	bisect-ppx-report send-to Coveralls

.PHONY: check
check: $(BIN)
	@$(BIN) build @check

.PHONY: fmt
fmt: $(BIN)
	@$(BIN) fmt

.PHONY: promote
promote: $(BIN)
	@$(BIN) promote

.PHONY: accept-corrections
accept-corrections: promote

.PHONY: clean
clean:
	rm -rf _boot _build

distclean: clean
	rm -f src/dune_rules/setup.ml

.PHONY: doc
doc:
	sphinx-build -W doc doc/_build

# livedoc-deps: you may need to [pip3 install sphinx-autobuild] and [pip3 install -r doc/requirements.txt]
livedoc:
	cd doc && sphinx-autobuild . _build --port 8888 -q --re-ignore '\.#.*'

update-jbuilds: $(BIN)
	$(BIN) build @doc/runtest --auto-promote

# If the first argument is "run"...
ifeq (dune,$(firstword $(MAKECMDGOALS)))
  # use the rest as arguments for "run"
  RUN_ARGS := $(wordlist 2,$(words $(MAKECMDGOALS)),$(MAKECMDGOALS))
  # ...and turn them into do-nothing targets
  $(eval $(RUN_ARGS):;@:)
endif

.PHONY: bench
bench: $(BIN)
	@$(BIN) exec -- ./bench/bench.exe $(BIN)

.PHONY: dune
dune: $(BIN)
	$(BIN) $(RUN_ARGS)

# Use this target to make sure that we always run the in source dune when making
# the release
.PHONY: opam-release
opam-release: dev
	$(BIN) exec -- $(MAKE) dune-release

dune-release:
	dune-release tag
	dune-release distrib --skip-build --skip-lint --skip-tests
# See https://github.com/ocamllabs/dune-release/issues/206
	DUNE_RELEASE_DELEGATE=github-dune-release-delegate dune-release publish distrib --verbose
	dune-release opam pkg
	dune-release opam submit

.PHONY: docker-build-image
docker-build-image:
	docker build -f docker/dev.Dockerfile -t dune .

.PHONY: docker-compose
docker-compose:
	docker compose -f docker/dev.yml run dune bash

=== debian/changelog ===
ocaml-dune (3.17.2-1build1) questing; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 16 Jun 2025 10:20:18 +0200

ocaml-dune (3.17.2-1) unstable; urgency=medium

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Tue, 11 Feb 2025 17:01:51 +0100

=== debian/control ===
--- 
+++ 
@@ -16,6 +16,7 @@
 Package: ocaml-dune
 Architecture: any
 Breaks:
+ ocplib-simplex-ocaml-dev (<< 0.5.1-3~),
  libsedlex-ocaml-dev (<< 2.1-4),
  jbuilder (<< 1.0~beta20-1),
  whitedune (<< 0.30.10-2.2),

## ocaml-dune 3.20.1

=== debian/changelog ===
ocaml-dune (3.20.1-1) unstable; urgency=medium

  * New upstream release
  * Bump Standards-Version to 4.7.2

 -- Stéphane Glondu <glondu@debian.org>  Wed, 03 Sep 2025 10:21:32 +0200

## ocaml-dune 3.20.2

=== Makefile ===
--- 
+++ 
@@ -12,7 +12,8 @@
 core_bench \
 patdiff
 
-TEST_OCAMLVERSION := 5.1.1
+TEST_OCAMLVERSION := 5.3.0
+# When updating this version, don't forget to also bump the number in the docs.
 
 -include Makefile.dev
 
@@ -23,6 +24,10 @@
 .PHONY: bootstrap
 bootstrap:
 	$(MAKE) -B $(BIN)
+
+.PHONY: test-bootstrap
+test-bootstrap:
+	@ocaml boot/bootstrap.ml --boot-dir _test_boot
 
 .PHONY: release
 release: $(BIN)
@@ -59,10 +64,6 @@
 dev-deps:
 	opam install -y . --deps-only --with-dev-setup
 
-.PHONY: coverage-deps
-coverage-deps:
-	opam install -y bisect_ppx
-
 .PHONY: dev-deps-sans-melange
 dev-deps-sans-melange: dev-deps
 
@@ -75,6 +76,7 @@
 	else \
 		opam switch create -y . $(TEST_OCAMLVERSION) --no-install ; \
 	fi
+	opam pin add -y . -n --with-version=dev
 	opam install -y . --deps-only --with-test --with-dev-setup
 	$(MAKE) install-ocamlformat
 	opam install -y $(DEV_DEPS)
@@ -103,10 +105,6 @@
 
 test-all-sans-melange: $(BIN)
 	$(BIN) build @runtest @runtest-js @runtest-coq
-
-test-coverage: $(BIN)
-	- $(BIN) build --instrument-with bisect_ppx --force @runtest
-	bisect-ppx-report send-to Coveralls
 
 .PHONY: check
 check: $(BIN)
@@ -167,7 +165,7 @@
 	dune-release tag
 	dune-release distrib --skip-build --skip-lint --skip-tests
 # See https://github.com/ocamllabs/dune-release/issues/206
-	DUNE_RELEASE_DELEGATE=github-dune-release-delegate dune-release publish distrib --verbose
+	DUNE_RELEASE_DELEGATE=github-dune-release-delegate dune-release publish --verbose
 	dune-release opam pkg
 	dune-release opam submit

=== doc/requirements.txt ===
sphinx >= 6
furo
sphinx-copybutton >= 0.5.0
sphinx-design
myst-parser

=== debian/changelog ===
ocaml-dune (3.20.2-3) unstable; urgency=medium

  * Skip flaky tests in autopkgtest

 -- Stéphane Glondu <glondu@debian.org>  Sun, 07 Sep 2025 08:07:40 +0200

ocaml-dune (3.20.2-2) unstable; urgency=medium

  * Fix autopkgtest on bytecode archs

 -- Stéphane Glondu <glondu@debian.org>  Sat, 06 Sep 2025 01:25:19 +0200

ocaml-dune (3.20.2-1) unstable; urgency=medium

  * New upstream release
  * Add autopkgtest

 -- Stéphane Glondu <glondu@debian.org>  Fri, 05 Sep 2025 11:27:15 +0200

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
  debhelper-compat (= 13),
  ocaml,
  dh-ocaml
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://github.com/ocaml/dune
 Vcs-Git: https://salsa.debian.org/ocaml-team/ocaml-dune.git

=== debian/rules ===
--- 
+++ 
@@ -24,17 +24,17 @@
 
 override_dh_auto_build:
 	ocaml boot/bootstrap.ml
-	./dune.exe build --profile dune-bootstrap dune.install
+	./dune.exe build --release --profile dune-bootstrap dune.install
 ifeq (,$(filter pkg.ocaml-dune.bootstrap,$(DEB_BUILD_PROFILES)))
-	./dune.exe build $(addsuffix .install,$(DEB_DUNE_OTHER_PACKAGES))
+	./dune.exe build --release $(addsuffix .install,$(DEB_DUNE_OTHER_PACKAGES))
 endif
 
 override_dh_auto_install:
-	./dune.exe install --destdir=$(DESTDIR) --prefix=/usr --libdir=$(OCAML_STDLIB_DIR) $(DEB_DUNE_ALL_PACKAGES)
+	./dune.exe install --release --destdir=$(DESTDIR) --prefix=/usr --libdir=$(OCAML_STDLIB_DIR) $(DEB_DUNE_ALL_PACKAGES)
 ifeq (,$(filter pkg.ocaml-dune.bootstrap,$(DEB_BUILD_PROFILES)))
 	rm -rf $(addprefix debian/tmp/usr/doc/,$(DEB_DUNE_OTHER_PACKAGES))
 endif
 	rm -f debian/tmp/usr/doc/dune/LICENSE.md
 
 override_dh_auto_test:
-# Upstream tests assume opam is installed; skip them
+# Upstream tests have many dependencies; rely on autopkgtest instead

=== debian/tests/control ===
Tests: tests
Depends:
 git,
 pkgconf,
 liblwt-ocaml-dev,
 libppx-inline-test-ocaml-dev,
 libppx-expect-ocaml-dev,
 libresult-ocaml-dev,
 @

=== debian/watch ===
version=4
opts="searchmode=plain, uversionmangle=s/\.(alpha|beta)/~$1/" \
https://api.github.com/repos/ocaml/dune/releases?per_page=50 \
https://github.com/ocaml/dune/releases/download/[^/]+/dune-@ANY_VERSION@.tbz
